﻿Imports System.Drawing

Public Class Form1

    Private Zero As Int32
    Private Gain As Int32
    Private Slot_Input As Int32
    Private Slot_Output As Int32
    Private Slot_SetZero As Int32
    Private Slot_GainPlus As Int32
    Private Slot_GainMinus As Int32
    Private Click_Volume As Int32
    Private Click_Frequency As Int32
    Private Alarm_Volume As Int32
    Private Alarm_Frequency As Int32
    Private Alarm_Level As Int32

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '
        ToolTips_Init()
        '
        ToolStrip1.Renderer = New ToolStripButtonRenderer
        ' -------------------------------------------
        Load_INI()
        StartThereminoHAL()
        SetLocales()
        Set_Props()
        Set_MeterScale()
        ' -------------------------------------------
        Timer1.Interval = 16
        Timer1.Start()
        ' -------------------------------------------
        EventsAreEnabled = True
        ' -------------------------------------------
        Me.Text = AppTitleAndVersion()
        ' -------------------------------------------
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        Save_INI()
        Me.Refresh()
        e.Cancel = False
        Timer1.Stop()
        StopThereminoHAL()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    'Private Sub Form_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
    '    If Not EventsAreEnabled Then Exit Sub
    'End Sub

    ' =========================================================================
    '   THEREMINO HAL - START STOP -
    ' =========================================================================
    Private HalProcess As Process = Nothing
    Private Sub StartThereminoHAL()
        Dim path As String = Application.StartupPath & "\Theremino_HAL.exe"
        If Not My.Computer.FileSystem.FileExists(path) Then
            path = Application.StartupPath & "\Theremino_HAL\Theremino_HAL.exe"
        End If
        If Not My.Computer.FileSystem.FileExists(path) Then Return
        Dim psi As New ProcessStartInfo
        psi.WorkingDirectory = IO.Path.GetDirectoryName(path)
        psi.FileName = path
        HalProcess = Process.Start(psi)
    End Sub
    Private Sub StopThereminoHAL()
        If HalProcess IsNot Nothing AndAlso Not HalProcess.HasExited Then
            Try
                HalProcess.CloseMainWindow()
            Finally
            End Try
        End If
    End Sub

    ' ===================================================================================
    '   MenuStrip and ToolStrip Gradients
    ' ===================================================================================
    Private Sub MenuStrip1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MenuStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    MenuStrip1.Width, MenuStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.FromArgb(230, 230, 230), _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Horizontal)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub

    ' ===================================================================================
    '   ToolStrip PressedButton color
    ' ===================================================================================
    Class ToolStripButtonRenderer
        Inherits System.Windows.Forms.ToolStripProfessionalRenderer
        Protected Overrides Sub OnRenderButtonBackground(ByVal e As ToolStripItemRenderEventArgs)
            Dim btn As ToolStripButton = CType(e.Item, ToolStripButton)
            If btn IsNot Nothing AndAlso btn.CheckOnClick AndAlso btn.Checked Then
                Dim bounds As Rectangle = New Rectangle(0, 0, e.Item.Width - 1, e.Item.Height - 1)
                Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                               Color.Gold, _
                                                               Color.FromArgb(250, 250, 250), _
                                                               Drawing2D.LinearGradientMode.Vertical)
                e.Graphics.FillRectangle(brush, bounds)
                e.Graphics.DrawRectangle(Pens.Orange, bounds)
            Else
                MyBase.OnRenderButtonBackground(e)
            End If
        End Sub
    End Class

    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub


    ' =======================================================================================
    '   MENU FILE
    ' =======================================================================================
    Private Sub Menu_File_LoadConfiguration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_LoadConfiguration.Click
        LoadConfiguration()
    End Sub
    Private Sub Menu_File_SaveConfigurationAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveConfigurationAs.Click
        SaveConfigurationAs()
    End Sub
    Private Sub Menu_File_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveImage.Click
        SaveImage("ThereminoGeiger_", Me)
    End Sub
    Private Sub Menu_File_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_Exit.Click
        Me.Close()
    End Sub

    ' =======================================================================================
    '   MENU TOOLS
    ' =======================================================================================
    Private Sub Menu_Tools_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs)

    End Sub

    ' =======================================================================================
    '   MENU LANGUAGE
    ' =======================================================================================
    Private Sub Menu_Language_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language.DropDownOpening
        For Each item As ToolStripMenuItem In Menu_Language.DropDownItems
            If item.Name.EndsWith(Language, StringComparison.InvariantCultureIgnoreCase) Then
                item.Select()
            End If
        Next
    End Sub
    Private Sub Menu_Language_Deutsch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Deutsch.Click
        Language = "Deutsch"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_English_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_English.Click
        Language = "English"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Espanol_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Espanol.Click
        Language = "Espanol"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Francais_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Francais.Click
        Language = "Francais"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Italian_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Italian.Click
        Language = "Italian"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Japanese_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Language_Japanese.Click
        Language = "Japanese"
        SetLocales()
        Save_INI()
    End Sub

    ' =======================================================================================
    '   MENU HELP
    ' =======================================================================================
    Private Sub Menu_Help_ProgramHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ProgramHelp.Click
        OpenLocalizedHelp("ProgramHelp", ".pdf")
    End Sub
    Private Sub Menu_Help_RadioactiveSamples_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("RadioactiveSamples")
    End Sub
    Private Sub Menu_Help_RadiationScales_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("RadiationScales")
    End Sub
    Private Sub Menu_Help_AmbientalRadiation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("AmbientalRadiation", ".pdf")
    End Sub
    Private Sub Menu_Help_Isotopes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("Isotopes")
    End Sub
    Private Sub Menu_Help_Procedures_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("Procedures")
    End Sub
    Private Sub Menu_Help_ClinicalEffects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("ClinicalEffects")
    End Sub
    Private Sub Menu_Help_GeigerTubes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("GeigerTubes", ".pdf")
    End Sub
    Private Sub Menu_Help_GeigerTubesCase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("GeigerTubesCase", ".pdf")
    End Sub
    Private Sub Menu_Help_LND7312_Case_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        OpenLocalizedHelp("LND7312_Case", ".pdf")
    End Sub
    Private Sub Menu_Help_OpenProgramFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_OpenProgramFolder.Click
        Process.Start(Application.StartupPath)
    End Sub
    Private Sub OpenLocalizedHelp(ByVal name As String, Optional ByVal ext As String = ".rtf")
        Dim fname As String = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_" & Strings.Left(Language, 3).ToUpper & ext)
        If FileExists(fname) Then
            Process.Start(fname)
        Else
            fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ENG" & ext)
            If FileExists(fname) Then
                Process.Start(fname)
            Else
                fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ITA" & ext)
                If FileExists(fname) Then
                    Process.Start(fname)
                Else
                    fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & ext)
                    If FileExists(fname) Then
                        Process.Start(fname)
                    End If
                End If
            End If
        End If
    End Sub

    ' =======================================================================================
    '   MENU ABOUT
    ' =======================================================================================
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog()
    End Sub

    ' =======================================================================================
    '   TOOLBAR
    ' =======================================================================================
    Private Sub ToolStripButton_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_SaveImage.Click
        ToolStripButton_SaveImage.Visible = False
        ToolStripButton_SaveImage.Visible = True
        Me.Refresh()
        SaveImage("ThereminoGeiger_", Me)
    End Sub

    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_Gain, _
                        " Speed" & vbCr & _
                        " - - - - - - - - - - - - -" & vbCr & _
                        "  5 = 1 hour" & vbCr & _
                        "  4 = 12 hours" & vbCr & _
                        "  3 = 1 day" & vbCr & _
                        "  2 = 7 days" & vbCr & _
                        "  1 = 30 days")
    End Sub


    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub buttons_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles _
                                                                        txt_Gain.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub


    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================
    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_Zero.LostFocus, _
                                                                          txt_Gain.LostFocus, _
                                                                          txt_SlotIn.LostFocus, _
                                                                          txt_SlotOut.LostFocus, _
                                                                          txt_SlotSetZero.LostFocus, _
                                                                          txt_SlotGainPlus.LostFocus, _
                                                                          txt_SlotGainMinus.LostFocus, _
                                                                          txt_ClickVolume.LostFocus, _
                                                                          txt_ClickFrequency.LostFocus, _
                                                                          txt_AlarmVolume.LostFocus, _
                                                                          txt_AlarmFrequency.LostFocus, _
                                                                          txt_AlarmLevel.LostFocus
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub


    ' ================================================================================================
    '   SET PROPERTIES
    ' ================================================================================================
    Private Sub Properties_TextChanged(ByVal sender As Object, _
                                       ByVal e As System.EventArgs) Handles txt_Zero.TextChanged, _
                                                                            txt_Gain.TextChanged, _
                                                                            txt_SlotIn.TextChanged, _
                                                                            txt_SlotOut.TextChanged, _
                                                                            txt_SlotSetZero.TextChanged, _
                                                                            txt_SlotGainPlus.TextChanged, _
                                                                            txt_SlotGainMinus.TextChanged, _
                                                                            txt_ClickVolume.TextChanged, _
                                                                            txt_ClickFrequency.TextChanged, _
                                                                            txt_AlarmVolume.TextChanged, _
                                                                            txt_AlarmFrequency.TextChanged, _
                                                                            txt_AlarmLevel.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub

    Private Sub Set_Props()
        Zero = txt_Zero.NumericValueInteger
        Gain = txt_Gain.NumericValueInteger
        Slot_Input = txt_SlotIn.NumericValueInteger
        Slot_Output = txt_SlotOut.NumericValueInteger
        Slot_SetZero = txt_SlotSetZero.NumericValueInteger
        Slot_GainPlus = txt_SlotGainPlus.NumericValueInteger
        Slot_GainMinus = txt_SlotGainMinus.NumericValueInteger
        Click_Volume = txt_ClickVolume.NumericValueInteger
        Click_Frequency = txt_ClickFrequency.NumericValueInteger
        Alarm_Volume = txt_AlarmVolume.NumericValueInteger
        Alarm_Frequency = txt_AlarmFrequency.NumericValueInteger
        Alarm_Level = txt_AlarmLevel.NumericValueInteger
    End Sub

    Private Sub Set_MeterScale()
        With AnalogMeter1
            .ScaleText = "Em/sec."
            .LinearScale = True
            .Speed = 0.2

            .MinValue = 0
            .MaxValue = 5
            .TickLargeFrequency = 1
            .TickSmallFrequency = 0.5
            .TickTinyFrequency = 0.1
            .TickLargeSize = 20
            .TickSmallSize = 15

            '.MinValue = 0
            '.MaxValue = 5000
            '.TickLargeFrequency = 1000
            '.TickSmallFrequency = 500
            '.TickTinyFrequency = 100
            '.TickLargeSize = 20
            '.TickSmallSize = 15

            '.MinValue = 0
            '.MaxValue = 500
            '.TickLargeFrequency = 100
            '.TickSmallFrequency = 50
            '.TickTinyFrequency = 10
            '.TickLargeSize = 20
            '.TickSmallSize = 15

            '.MinValue = 0
            '.MaxValue = 5000
            '.TickLargeFrequency = 1000
            '.TickSmallFrequency = 500
            '.TickTinyFrequency = 100
            '.TickLargeSize = 20
            '.TickSmallSize = 15
        End With
    End Sub


    ' ================================================================================================
    '    TIMED EXECUTION - FAST TIMER ( 60 Hz )
    ' ================================================================================================
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        ' ---------------------------------- 
        If Slot_Input >= 0 Then
            Dim n As Single
            n = Slots.ReadSlot(Slot_Input)

            ' -------------------------------------------------- azzeramento e guadagno
            n = Gain * (n - Zero) / 1000.0F

            ' -------------------------------------------------- limitazione per non rompere la lancetta
            If n > 1 Then n = 1
            If n < 0 Then n = 0

            ' -------------------------------------------------- set meter position
            AnalogMeter1.Value = n * AnalogMeter1.MaxValue
            AnalogMeter1.Refresh()
        End If

        'If Slot_Output >= 0 Then
        '    'If CanUseWindowsDlls() Then
        '    '    If btn_OutputLinear.Checked Then
        '    '        WriteSlot(Slot_Output, 1000 * Form2.AnalogUsh)
        '    '    Else
        '    '        WriteSlot(Slot_Output, 1000 * CSng(Math.Log10(Form2.AnalogUsh)))
        '    '    End If
        '    'Else
        '    '    If btn_OutputLinear.Checked Then
        '    '        WriteSlot_Unix(Slot_Output, 1000 * Form2.AnalogUsh)
        '    '    Else
        '    '        WriteSlot_Unix(Slot_Output, 1000 * CSng(Math.Log10(Form2.AnalogUsh)))
        '    '    End If
        '    'End If
        'End If

    End Sub


End Class